Index: include/dahdi/kernel.h
===================================================================
--- include/dahdi/kernel.h	(revision 7107)
+++ include/dahdi/kernel.h	(working copy)
@@ -35,8 +35,22 @@
 
 #include <dahdi/user.h>
 #include <dahdi/fasthdlc.h>
+#include <dahdi/dahdi_config.h>
 
-#include <dahdi/dahdi_config.h>
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/selinfo.h>
+#include <sys/taskqueue.h>
+#include <sys/uio.h>
+
+#include <dahdi/compat/types.h>
+#include <dahdi/compat/list.h>
+#include <dahdi/compat/bsd.h>
+
+#define _RETVAL(errno)	(errno)
+
+#else /* !__FreeBSD */
 #include <linux/version.h>
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
 #include <linux/config.h>
@@ -85,6 +99,11 @@
 #endif
 #endif
 
+#define spin_lock_destroy(lock)
+#define _LIST_HEAD(n)	LIST_HEAD(n)
+#define _RETVAL(errno)	(-(errno))
+#endif /* !__FreeBSD__ */
+
 /*! Default chunk size for conferences and such -- static right now, might make
    variable sometime.  8 samples = 1 ms = most frequent service interval possible
    for a USB device */
@@ -257,10 +276,12 @@
 	/*! The name of the factory. */
 	const char *name;
 
+#if !defined(__FreeBSD__)
 	/*! Pointer to the module that owns this factory; the module's reference count will be
 	 * incremented/decremented by the DAHDI core as needed.
 	 */
 	struct module *owner;
+#endif
 
 	/*! \brief Function to create an instance of the echocan.
 	 * \param[in] ecp Structure defining parameters to be used for the instance creation.
@@ -369,7 +390,7 @@
 			/*! The echocan enabled its NLP automatically.
 			 */
 			u32 NLP_auto_enabled:1;
-		};
+		} e;
 	} events;
 };
 
@@ -427,9 +448,12 @@
 
 	/* Specified by driver, readable by DAHDI */
 	void *pvt;			/*!< Private channel data */
+#if defined(__FreeBSD__)
+	struct cdev *file;	/*!< Device structure */
+#else
 	struct file *file;	/*!< File structure */
+#endif
 	
-	
 	struct dahdi_span	*span;			/*!< Span we're a member of */
 	int		sig;			/*!< Signalling */
 	int		sigcap;			/*!< Capability for signalling */
@@ -491,7 +515,12 @@
 
 	/* I/O Mask */	
 	int		iomask;  /*! I/O Mux signal mask */
+#if defined(__FreeBSD__)
+	struct selinfo sel;	/*! thingy for select stuff */
+	struct task selwakeup_task;
+#else
 	wait_queue_head_t sel;	/*! thingy for select stuff */
+#endif
 	
 	/* HDLC state machines */
 	struct fasthdlc_state txhdlc;
@@ -519,7 +548,6 @@
 	short	conflast1[DAHDI_MAX_CHUNKSIZE];		/*!< Last conference sample  -- pseudo part of channel */
 	short	conflast2[DAHDI_MAX_CHUNKSIZE];		/*!< Previous last conference sample -- pseudo part of channel */
 	
-
 	/*! The echo canceler module that should be used to create an
 	   instance when this channel needs one */
 	const struct dahdi_echocan_factory *ec_factory;
@@ -644,6 +672,9 @@
 struct dahdi_chardev {
 	const char *name;
 	__u8 minor;
+#if defined(__FreeBSD__)
+	struct cdev *dev;
+#endif
 };
 
 int dahdi_register_chardev(struct dahdi_chardev *dev);
@@ -734,7 +765,11 @@
 
 struct dahdi_span {
 	spinlock_t lock;
+#if defined(__FreeBSD__)
+	int refcount;
+#else
 	struct module *owner;		/*!< Which module is exporting this span. */
+#endif
 	void *pvt;			/*!< Private stuff */
 	char name[40];			/*!< Span name */
 	char desc[80];			/*!< Span description */
@@ -916,7 +951,12 @@
 	int numchannels;
 	unsigned int srcfmts;
 	unsigned int dstfmts;
+#if defined(__FreeBSD__)
+	int (*write)(struct dahdi_transcoder_channel *channel, struct uio *uio, int ioflags);
+	int (*read)(struct dahdi_transcoder_channel *channel, struct uio *uio, int ioflags);
+#else
 	struct file_operations fops;
+#endif
 	int (*allocate)(struct dahdi_transcoder_channel *channel);
 	int (*release)(struct dahdi_transcoder_channel *channel);
 	/* Transcoder channels */
@@ -1042,7 +1082,9 @@
 void dahdi_ec_chunk(struct dahdi_chan *chan, unsigned char *rxchunk, const unsigned char *txchunk);
 void dahdi_ec_span(struct dahdi_span *span);
 
+#if !defined(__FreeBSD__)
 extern struct file_operations *dahdi_transcode_fops;
+#endif
 
 /* Don't use these directly -- they're not guaranteed to
    be there. */
@@ -1163,7 +1205,7 @@
 /*! Maximum audio mask */
 #define DAHDI_FORMAT_AUDIO_MASK	((1 << 16) - 1)
 
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,14)
+#if defined(__FreeBSD__) || LINUX_VERSION_CODE < KERNEL_VERSION(2,6,14)
 #define kzalloc(a, b) kcalloc(1, a, b)
 #endif
 
Index: freebsd/wcb4xxp/Makefile
===================================================================
--- freebsd/wcb4xxp/Makefile	(revision 0)
+++ freebsd/wcb4xxp/Makefile	(revision 0)
@@ -0,0 +1,10 @@
+# $Id$
+
+.PATH: ${.CURDIR}/../../drivers/dahdi/wcb4xxp
+
+KMOD=	wcb4xxp
+SRCS=	base.c
+SRCS+=	device_if.h bus_if.h pci_if.h
+CFLAGS=	--param inline-unit-growth=100
+
+.include <bsd.kmod.mk>
Index: freebsd/dahdi_echocan_sec/Makefile
===================================================================
--- freebsd/dahdi_echocan_sec/Makefile	(revision 0)
+++ freebsd/dahdi_echocan_sec/Makefile	(revision 0)
@@ -0,0 +1,8 @@
+# $Id$
+
+.PATH:	${.CURDIR}/../../drivers/dahdi
+
+KMOD=	dahdi_echocan_sec
+SRCS=	dahdi_echocan_sec.c
+
+.include <bsd.kmod.mk>
Index: freebsd/dahdi_dummy/dahdi_dummy.c
===================================================================
--- freebsd/dahdi_dummy/dahdi_dummy.c	(revision 0)
+++ freebsd/dahdi_dummy/dahdi_dummy.c	(revision 0)
@@ -0,0 +1,217 @@
+/*
+ * Dummy DAHDI Driver for DAHDI Telephony interface
+ *
+ * Required:  kernel compiled with "options HZ=1000" 
+ * Written by Chris Stenton <jacs@gnome.co.uk>
+ * 
+ * Copyright (C) 2004, Digium, Inc.
+ *
+ * All rights reserved.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * Rewritten to use the time of day clock (which should be ntp synced
+ * for this to work perfectly) by David G. Lawrence <dg@dglawrence.com>.
+ * July 27th, 2007.
+ *
+ */
+
+#include <sys/cdefs.h>
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/conf.h>
+#include <sys/uio.h>
+#include <sys/kernel.h>
+#include <sys/malloc.h>
+#include <sys/module.h>
+
+#include <sys/conf.h>
+#include <sys/errno.h>
+
+#include <dahdi/kernel.h>
+
+struct dahdi_dummy {
+	struct dahdi_span span;
+	struct dahdi_chan _chan;
+	struct dahdi_chan *chan;
+};
+
+MALLOC_DEFINE(M_DAHDIDUMMY, "dahdy_dummy", "DAHDI dummy interface data structures");
+
+#ifndef timersub
+#define timersub(tvp, uvp, vvp)                                         \
+        do {                                                            \
+                (vvp)->tv_sec = (tvp)->tv_sec - (uvp)->tv_sec;          \
+                (vvp)->tv_usec = (tvp)->tv_usec - (uvp)->tv_usec;       \
+                if ((vvp)->tv_usec < 0) {                               \
+                        (vvp)->tv_sec--;                                \
+                        (vvp)->tv_usec += 1000000;                      \
+                }                                                       \
+        } while (0)
+#endif
+
+static struct callout_handle dahdi_dummy_timer_handle = CALLOUT_HANDLE_INITIALIZER(&dahdi_dummy_timer_handle);
+
+static struct dahdi_dummy *dahdi_d;
+
+static int debug = 0;
+static struct timeval basetime, curtime, sleeptime;
+
+static __inline void
+dahdi_dummy_timer(void *arg)
+{
+	int i, ticks;
+
+loop:
+	for (i = 0; i < hz / 100; i++) {
+		dahdi_receive(&dahdi_d->span);
+		dahdi_transmit(&dahdi_d->span);
+	}
+
+fixtime:
+	microtime(&curtime);
+
+	/*
+	 * Sleep until the next 10ms boundry.
+	 */
+	basetime.tv_usec += 10000;
+	if (basetime.tv_usec >= 1000000) {
+		basetime.tv_sec++;
+		basetime.tv_usec -= 1000000;
+	}
+	timersub(&basetime, &curtime, &sleeptime);
+
+	/*
+	 * Detect if we've gotten behind and need to start our processing
+	 * immediately.
+	 */
+	if (sleeptime.tv_sec < 0 || sleeptime.tv_usec == 0) {
+		/*
+		 * Limit how far we can get behind to something reasonable (1 sec)
+		 * so that we don't go nuts when something (ntp or admin) sets the
+		 * clock forward by a large amount.
+		 */
+		if (sleeptime.tv_sec < -1) {
+			basetime.tv_sec = curtime.tv_sec;
+			basetime.tv_usec = curtime.tv_usec;
+			goto fixtime;
+		}
+		goto loop;
+	}
+	/*
+	 * Detect if something is messing with the system clock by
+	 * checking that the sleep time is no more than 20ms and
+	 * resetting our base time if it is. This case will occur if
+	 * the system clock has been reset to an earlier time.
+	 */
+	if (sleeptime.tv_sec > 0 || sleeptime.tv_usec > 20000) {
+		basetime.tv_sec = curtime.tv_sec;
+		basetime.tv_usec = curtime.tv_usec;
+		goto fixtime;
+	}
+
+	ticks = sleeptime.tv_usec * hz / 1000000;
+	if (ticks == 0)
+		goto loop;
+
+	dahdi_dummy_timer_handle = timeout(dahdi_dummy_timer, NULL, ticks);
+}
+
+static int
+dahdi_dummy_initialize(struct dahdi_dummy *dahdi_d)
+{
+	/* DAHDI stuff */
+	dahdi_d->chan = &dahdi_d->_chan;
+	sprintf(dahdi_d->span.name, "DAHDI_DUMMY/1");
+	sprintf(dahdi_d->span.desc, "%s %d", dahdi_d->span.name, 1);
+	sprintf(dahdi_d->chan->name, "DAHDI_DUMMY/%d/%d", 1, 0);
+	dahdi_copy_string(dahdi_d->span.devicetype, "DAHDI Dummy Timing", sizeof(dahdi_d->span.devicetype));
+	dahdi_d->chan->chanpos = 1;
+	dahdi_d->span.chans = &dahdi_d->chan;
+	dahdi_d->span.channels = 0;		/* no channels on our span */
+	dahdi_d->span.deflaw = DAHDI_LAW_MULAW;
+	dahdi_d->span.pvt = dahdi_d;
+	dahdi_d->chan->pvt = dahdi_d;
+	if (dahdi_register(&dahdi_d->span, 0)) {
+		return -1;
+	}
+	return 0;
+}
+
+static int
+dahdi_dummy_attach(void)
+{
+	dahdi_d = malloc(sizeof(struct dahdi_dummy), M_DAHDIDUMMY, M_NOWAIT | M_ZERO);
+	if (dahdi_d == NULL) {
+		printf("dahdi_dummy: Unable to allocate memory\n");
+		return ENOMEM;
+	}
+
+	if (dahdi_dummy_initialize(dahdi_d)) {
+		printf("dahdi_dummy: Unable to intialize zaptel driver\n");
+		free(dahdi_d, M_DAHDIDUMMY);
+		return ENODEV;
+	}
+
+	microtime(&basetime);
+	dahdi_dummy_timer_handle = timeout(dahdi_dummy_timer, NULL, 1);
+
+	if (debug)
+		printf("dahdi_dummy: init() finished\n");
+	return 0;
+}
+
+static void
+cleanup_module(void)
+{
+	untimeout(dahdi_dummy_timer, NULL, dahdi_dummy_timer_handle);
+	dahdi_unregister(&dahdi_d->span);
+	free(dahdi_d, M_DAHDIDUMMY);
+
+	if (debug)
+		printf("dahdi_dummy: cleanup() finished\n");
+}
+
+static int
+dahdi_dummy_modevent(module_t mod,int  type, void*  data)
+{
+	int ret;
+
+	switch (type) {
+	case MOD_LOAD:
+		 ret = dahdi_dummy_attach();
+		 if (ret)
+			 return (ret);
+		 printf("dahdi_dummy: loaded\n");
+		 if (hz < 1000) {
+			 printf("dahdi_dummy: WARNING Ticker rate only %d. Timer will not work well!!\nRecompile kernel with \"options HZ=1000\"\n", hz);
+		 }
+		break;
+
+	case MOD_UNLOAD:
+		cleanup_module();
+		printf("dahdi_dummy: unloaded\n");
+		break;
+
+	default:
+		return EOPNOTSUPP;
+	}
+	return 0;
+}
+
+MODULE_VERSION(dahdi_dummy, 1);
+MODULE_DEPEND(dahdi_dummy, dahdi, 1, 1, 1);
+DEV_MODULE(dahdi_dummy, dahdi_dummy_modevent, NULL);
Index: freebsd/dahdi_dummy/Makefile
===================================================================
--- freebsd/dahdi_dummy/Makefile	(revision 0)
+++ freebsd/dahdi_dummy/Makefile	(revision 0)
@@ -0,0 +1,6 @@
+# $Id: Makefile 277 2008-12-22 15:25:03Z ys $
+
+SRCS=	dahdi_dummy.c
+KMOD=	dahdi_dummy
+
+.include <bsd.kmod.mk>
Index: freebsd/Makefile.inc
===================================================================
--- freebsd/Makefile.inc	(revision 0)
+++ freebsd/Makefile.inc	(revision 0)
@@ -0,0 +1,13 @@
+# $Id$
+
+PREFIX?=	/usr/local
+INCLUDEDIR=	${.CURDIR}/../../include
+KMODDIR?=	${PREFIX}/lib/dahdi
+
+CFLAGS+=	-I${INCLUDEDIR} -D__KERNEL__
+
+MKDIR?=		mkdir -p
+INSTALL_DATA?=	${INSTALL} -m ${SHAREMODE} -o ${SHAREOWN} -g ${SHAREGRP} -c
+
+beforeinstall:
+	${MKDIR} ${KMODDIR}
Index: freebsd/dahdi_echocan_sec2/Makefile
===================================================================
--- freebsd/dahdi_echocan_sec2/Makefile	(revision 0)
+++ freebsd/dahdi_echocan_sec2/Makefile	(revision 0)
@@ -0,0 +1,8 @@
+# $Id$
+
+.PATH:	${.CURDIR}/../../drivers/dahdi
+
+KMOD=	dahdi_echocan_sec2
+SRCS=	dahdi_echocan_sec2.c
+
+.include <bsd.kmod.mk>
Index: freebsd/dahdi_echocan_kb1/Makefile
===================================================================
--- freebsd/dahdi_echocan_kb1/Makefile	(revision 0)
+++ freebsd/dahdi_echocan_kb1/Makefile	(revision 0)
@@ -0,0 +1,8 @@
+# $Id$
+
+.PATH:	${.CURDIR}/../../drivers/dahdi
+
+KMOD=	dahdi_echocan_kb1
+SRCS=	dahdi_echocan_kb1.c
+
+.include <bsd.kmod.mk>
Index: freebsd/dahdi/Makefile
===================================================================
--- freebsd/dahdi/Makefile	(revision 0)
+++ freebsd/dahdi/Makefile	(revision 0)
@@ -0,0 +1,24 @@
+# $Id$
+
+.PATH: ${.CURDIR}/../../drivers/dahdi
+
+KMOD=		dahdi
+SRCS=		dahdi-base.c version.h
+SRCS+=		device_if.h bus_if.h
+CLEANFILES=	version.h
+INCS=		user.h wctdm_user.h compat/types.h
+
+DAHDIVERSION!=	${.CURDIR}/../../build_tools/make_version ../.. dahdi/linux
+version.h::
+	@DAHDIVERSION="${DAHDIVERSION}" ${.CURDIR}/../../build_tools/make_version_h >${.TARGET}.tmp
+	@if ! cmp -s ${.TARGET}.tmp ${.TARGET}; then mv ${.TARGET}.tmp ${.TARGET}; fi
+	@rm -f ${.TARGET}.tmp
+
+afterinstall:
+	${MKDIR} ${PREFIX}/include/dahdi/compat
+.for _h in ${INCS}
+	${INSTALL_DATA} ${INCLUDEDIR}/dahdi/${_h} ${PREFIX}/include/dahdi/${_h:H}
+.endfor
+
+.include <bsd.kmod.mk>
+.include <bsd.own.mk>
Index: freebsd/dahdi_echocan_jpah/Makefile
===================================================================
--- freebsd/dahdi_echocan_jpah/Makefile	(revision 0)
+++ freebsd/dahdi_echocan_jpah/Makefile	(revision 0)
@@ -0,0 +1,8 @@
+# $Id$
+
+.PATH:	${.CURDIR}/../../drivers/dahdi
+
+KMOD=	dahdi_echocan_jpah
+SRCS=	dahdi_echocan_jpah.c
+
+.include <bsd.kmod.mk>
Index: freebsd/Makefile
===================================================================
--- freebsd/Makefile	(revision 0)
+++ freebsd/Makefile	(revision 0)
@@ -0,0 +1,13 @@
+# $Id$
+
+SUBDIR=\
+	dahdi\
+	dahdi_dummy\
+	dahdi_echocan_jpah\
+	dahdi_echocan_kb1\
+	dahdi_echocan_mg2\
+	dahdi_echocan_sec\
+	dahdi_echocan_sec2\
+	wcb4xxp
+
+.include <bsd.subdir.mk>
Index: freebsd/dahdi_echocan_mg2/Makefile
===================================================================
--- freebsd/dahdi_echocan_mg2/Makefile	(revision 0)
+++ freebsd/dahdi_echocan_mg2/Makefile	(revision 0)
@@ -0,0 +1,8 @@
+# $Id$
+
+.PATH:	${.CURDIR}/../../drivers/dahdi
+
+KMOD=	dahdi_echocan_mg2
+SRCS=	dahdi_echocan_mg2.c
+
+.include <bsd.kmod.mk>
Index: drivers/dahdi/dahdi_echocan_mg2.c
===================================================================
--- drivers/dahdi/dahdi_echocan_mg2.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_mg2.c	(working copy)
@@ -31,6 +31,18 @@
  * this program for more details.
  */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printf("%s: " fmt, __FUNCTION__, ## args)
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/slab.h>
 #include <linux/errno.h>
@@ -39,14 +51,15 @@
 #include <linux/ctype.h>
 #include <linux/moduleparam.h>
 
+#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printk("%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
+#endif /* !__FreeBSD__ */
+
 #include <dahdi/kernel.h>
 
 static int debug;
 static int aggressive;
 
-#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
-#define debug_printk(level, fmt, args...) if (debug >= level) printk("%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
-
 #define ABS(a) abs(a!=-32768?a:-32767)
 
 #define RESTORE_COEFFS {\
@@ -183,8 +196,10 @@
 
 static const struct dahdi_echocan_factory my_factory = {
 	.name = "MG2",
+	.echocan_create = echo_can_create,
+#if !defined(__FreeBSD__)
 	.owner = THIS_MODULE,
-	.echocan_create = echo_can_create,
+#endif
 };
 
 static const struct dahdi_echocan_features my_features = {
@@ -311,7 +326,7 @@
 	unsigned long tmp;
 
 	/* Double-word align past end of state */
-	ptr += sizeof(*pvt);
+	ptr = (char *) ptr + sizeof(*pvt);
 	tmp = (unsigned long)ptr;
 	tmp += 3;
 	tmp &= ~3L;
@@ -323,26 +338,26 @@
   
 	/* Allocate coefficient memory */
 	pvt->a_i = ptr;
-	ptr += (sizeof(int) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(int) * pvt->N_d);
 	pvt->a_s = ptr;
-	ptr += (sizeof(short) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(short) * pvt->N_d);
 
 	/* Allocate backup memory */
 	pvt->b_i = ptr;
-	ptr += (sizeof(int) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(int) * pvt->N_d);
 	pvt->c_i = ptr;
-	ptr += (sizeof(int) * pvt->N_d);
+	ptr = (char *) ptr + (sizeof(int) * pvt->N_d);
 
 	/* Reset Y circular buffer (short version) */
 	init_cb_s(&pvt->y_s, maxy, ptr);
-	ptr += (sizeof(short) * (maxy) * 2);
+	ptr = (char *) ptr + (sizeof(short) * (maxy) * 2);
   
 	/* Reset Sigma circular buffer (short version for FIR filter) */
 	init_cb_s(&pvt->s_s, (1 << DEFAULT_ALPHA_ST_I), ptr);
-	ptr += (sizeof(short) * (1 << DEFAULT_ALPHA_ST_I) * 2);
+	ptr = (char *) ptr + (sizeof(short) * (1 << DEFAULT_ALPHA_ST_I) * 2);
 
 	init_cb_s(&pvt->u_s, maxu, ptr);
-	ptr += (sizeof(short) * maxu * 2);
+	ptr = (char *) ptr + (sizeof(short) * maxu * 2);
 
 	/* Allocate a buffer for the reference signal power computation */
 	init_cb_s(&pvt->y_tilde_s, pvt->N_d, ptr);
@@ -387,7 +402,7 @@
 }
 
 #ifdef DC_NORMALIZE
-short inline dc_removal(int *dc_estimate, short samp)
+static short inline dc_removal(int *dc_estimate, short samp)
 {
 	*dc_estimate += ((((int)samp << 15) - *dc_estimate) >> 9);
 	return samp - (*dc_estimate >> 15);
@@ -799,7 +814,7 @@
 
 	pvt = kzalloc(size, GFP_KERNEL);
 	if (!pvt)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	pvt->dahdi.ops = &my_ops;
 
@@ -815,7 +830,7 @@
 			printk(KERN_WARNING "Unknown parameter supplied to MG2 echo canceler: '%s'\n", p[x].name);
 			kfree(pvt);
 
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
 	}
 
@@ -867,7 +882,7 @@
 	if (dahdi_register_echocan_factory(&my_factory)) {
 		module_printk(KERN_ERR, "could not register with DAHDI core\n");
 
-		return -EPERM;
+		return _RETVAL(EPERM);
 	}
 
 	module_printk(KERN_NOTICE, "Registered echo canceler '%s'\n", my_factory.name);
@@ -880,6 +895,26 @@
 	dahdi_unregister_echocan_factory(&my_factory);
 }
 
+#if defined(__FreeBSD__)
+static int
+echocan_mg2_modevent(module_t mod __unused, int type, void *data __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		return mod_init();
+	case MOD_UNLOAD:
+		mod_exit();
+		return 0;
+	default:
+		return _RETVAL(EOPNOTSUPP);
+	}
+}
+
+DEV_MODULE(dahdi_echocan_mg2, echocan_mg2_modevent, NULL);
+MODULE_VERSION(dahdi_echocan_mg2, 1);
+MODULE_DEPEND(dahdi_echocan_mg2, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
 module_param(debug, int, S_IRUGO | S_IWUSR);
 module_param(aggressive, int, S_IRUGO | S_IWUSR);
 
@@ -889,3 +924,4 @@
 
 module_init(mod_init);
 module_exit(mod_exit);
+#endif /* !__FreeBSD__ */
